package assignment06;

/*
*  Assignment 06:
*    Anagram
*           Array Exercise 2
*
 */
public class Anagram {

    public static void main(String[] args) {

        String[] words = {"deductions", "discounted", "discounter", "introduces",
            "reductions", "harmonicas", "maraschino", "percussion", "supersonic"};
       
        // we pick one as the search term and search for its anagrams
        String anagram = words[(int) (Math.random() * 9)];   
        
        // how many of each letter of the alphabet exists in this word
        int[] anagram_histogram = countLetters(anagram);

        System.out.println("The word \"" + anagram + "\" is an anagram for:");

        // check each String s in the words array for being an anagram
        for (String s : words) {
            if (s.equals(anagram)) {
                continue;    //skip the search term itself
            }   
            //count letters for the String s as well
            int[] s_histogram = countLetters(s);
            // compare the letter counts for the anagram and the String s
            // if they are the same, it is an anagram
            boolean isAnagram = true;
            for (int i = 0; i < s_histogram.length; i++) {
                if (s_histogram[i] != anagram_histogram[i]) {
                    isAnagram = false;
                    break;
                }
            }
            if (isAnagram) {
                System.out.println(" " + s);
            }
        }
        System.out.println("All done. ");
    }

    // this is a helper method for counting
    // how many of each letter exists in a given String.
    // the method returns an array of letter counts
    // from a-z.
    private static int[] countLetters(String s) {
        //convert the String into all lowercase
        //and convert it to a char array
        char[] s_arr = s.toLowerCase().toCharArray();
        // how many counters do we need?
        int alphabet_size = 'z' - 'a' + 1;
        // initialize the array of counters
        int[] counters = new int[alphabet_size];
        // for each character in the array
        // we will increment the letter counter for that character
        // skipping whitespaces
        for (char c : s_arr) {
            if (!Character.isWhitespace(c)) {
                counters[c - 'a']++;
            }
        }
        return counters;
    }
}
